#include <GMLuaModule.h>

#include <eiface.h>

#include <windows.h>
#include <detours.h>

#include "sigscan.h"

GMOD_MODULE(Open, Close);

ILuaInterface *gLua = NULL;

CSigScan BindKey_Sig;

typedef void (*BindKey_t)(const CCommand &args);

void (*BindKeyT)(const CCommand &args);

void BindKeyD(const CCommand &args)
{
	ILuaObject *hookT = gLua->GetGlobal("hook");

		gLua->Push(hookT->GetMember("Call"));

		gLua->Push("BindKey");
		gLua->PushNil();
		
		ILuaObject *argT = gLua->GetNewTable();

			for (int i=1;i<args.ArgC();i++)
			{
				argT->SetMember(i, args.Arg(i));
			}
			
			gLua->Push(argT);

		argT->UnReference();

		gLua->Call(3, 1);

	hookT->UnReference();

	if (gLua->GetReturn(0)->isNil())
		BindKeyT(args);
}

int Open(lua_State *L)
{
	gLua = Lua();
	
	CreateInterfaceFn engineFactory = Sys_GetFactory("engine.dll");

	CSigScan::sigscan_dllfunc = (CreateInterfaceFn)engineFactory(INTERFACEVERSION_VENGINESERVER, NULL);
	CSigScan::GetDllMemInfo();

	BindKey_Sig.Init((unsigned char *)"\x81\xEC\x04\x04\x00\x00\x55\x8B\xAC\x24\x0C\x04\x00\x00\x57\x8B\x7D\x00", "xxxxxxxxxxxxxxxxxx", 18);

	//81 EC 04 04 00 00 55 8B AC 24 0C 04 00 00 57
	//8B 7D 00 

	if (BindKey_Sig.is_set)
	{	
		BindKeyT = (BindKey_t)BindKey_Sig.sig_addr;

		DetourTransactionBegin();
		DetourUpdateThread(GetCurrentThread());

		DetourAttach(&(PVOID &)BindKeyT, BindKeyD);

		DetourTransactionCommit();
	}
	else
	{
		gLua->Msg("[BindKey] Signature scan failed\n");
	}

	return 0;
}

int Close(lua_State *L)
{
	if (BindKey_Sig.is_set)
	{
		DetourTransactionBegin();
		DetourUpdateThread(GetCurrentThread());

		DetourDetach(&(PVOID &)BindKeyT, BindKeyD);

		DetourTransactionCommit();
	}

	return 0;
}